using System;
using System.Collections.Generic;
using System.Text;
using System.Collections;

namespace FM
{
    /// <summary>
    /// Trieda zoskupuje ablny pre novovytvoren uzly skupn a uzly vlastnost.
    /// </summary>
    [Serializable]
    public class NodeAiTemplates
    {
        private AiItems diagramAiItems;
        /// <summary>
        /// Je odkazom na ablnu doplujcich vlastnost, ktor bude pridan k novovytvorenemu diagramu.
        /// </summary>
        public AiItems DiagramAiItems
        {
            get { return diagramAiItems; }
        }
       
        private AiItems featureAiItems;
        /// <summary>
        /// Je odkazom na ablnu doplujcich vlastnost, ktor bude pridan novovytvorenej vlastnosti v diagrame.
        /// </summary>
        public AiItems FeatureAiItems
        {
            get { return featureAiItems; }
        }

        private AiItems projectAiItems;
        /// <summary>
        /// Je odkazom na ablnu doplujcich vlastnost, ktor bude pridan k novovytvorenemu projektu.
        /// </summary>
        public AiItems ProjectAiItems
        {
            get { return projectAiItems; }
        }

        /// <summary>
        /// Kontruktor triedy ktor inicializuje referencie abln.
        /// </summary>
        public NodeAiTemplates()
        {
            diagramAiItems = new AiItems();
            featureAiItems = new AiItems();
            projectAiItems = new AiItems();
        }
        /// <summary>
        /// Koprovanie AiTemplates
        /// TODO...
        /// </summary>
        /// <returns>Vrti kpiu AiTemplates.</returns>
        public NodeAiTemplates Clone()
        {
            NodeAiTemplates copy = (NodeAiTemplates)this.MemberwiseClone();
            copy.diagramAiItems = this.diagramAiItems.Clone();
            copy.featureAiItems = this.featureAiItems.Clone();
            copy.projectAiItems = this.projectAiItems.Clone();
            return copy;
        }
    }
}
