using System;
using System.Collections;
using System.Collections.Generic;
using System.Text;

namespace FM
{
    /// <summary>
    /// Udriava referencie na vetky mon Ai hodnoty, zorganizovan pod klmi.
    /// Treba zabezpei maximlne jednu intanciu.
    /// </summary>
    [Serializable] 
    public class AllPossibleAiValues
    {
        private ArrayList allPossibleValues;
        /// <summary>
        ///  Vrti referenciu na pole obsahujce referencie na vetky mon Ai hodnoty. 
        /// </summary>
        public ArrayList AllPossibleValues
        {
            get { return allPossibleValues; }
        }
        /// <summary>
        /// Kontruktor trukry udriavajcej vetky mon referencie na Ai hodnoty.
        /// </summary>
        public AllPossibleAiValues()
        {
            allPossibleValues = new ArrayList();
        }

        private void addReferenceToAiValuesSet(PossibleAiValues possibleAiValuesReference)
        {
            allPossibleValues.Add(possibleAiValuesReference);
        }
        private void removeReferenceToAiValuesSet(PossibleAiValues possibleAiValuesReference)
        {
            allPossibleValues.Remove(possibleAiValuesReference);
        }
        /// <summary>
        /// Vytvor mnoinu nastavitench hodnt, ale iba v prpade, e u tak neexistuje. 
        /// </summary>
        /// <param name="key">True - ak sa vytvor, False - inak.</param>
        /// <returns></returns>
        public bool CreatePossibleAiValuesSet(String key)
        {
            if (ExistPossibleAiValuesSet(key))
                return false;

            addReferenceToAiValuesSet(new PossibleAiValues(key));
            return true;
        }
        /// <summary>
        /// Vymae mnoinu nastavitench hodnt pre dan k, ale iba v prpade, ak existuje.
        /// </summary>
        /// <param name="key">Kl pre mnoinu nastavitench hodnt.</param>
        /// <returns>True - ak sa vymae, False - inak.</returns>
        public bool DeletePossibleAiValuesSet(String key)
        {
            PossibleAiValues pV = GetReferenceToKey(key);
            if (pV != null)
            {
                pV.PossibleValues.Clear();
                removeReferenceToAiValuesSet(pV);
                return true;
            }
            return false;
        }
        /// <summary>
        /// Testuje, i existuje mnoina nastavitench hodnt pre dan k.
        /// </summary>
        /// <param name="key">K pre mnoinu nastavitench hodnt.</param>
        /// <returns>True - ak existuje, False - ak neexistuje.</returns>
        public bool ExistPossibleAiValuesSet(String key)
        {
            foreach (PossibleAiValues pV in allPossibleValues)
            {
                if (pV.Key == key)
                {
                    return true;
                }
            }
            return false;
        }
        /// <summary>
        /// Funkcia vracia referenciu k mnoine nastavitench hodnt pre dan k.
        /// </summary>
        /// <param name="key">K k mnoine nastavitench hodnt.</param>
        /// <returns>Vracia referenciu k mnoine nastavitench hodnt.</returns>
        public PossibleAiValues GetReferenceToKey(String key)
        {
            foreach (PossibleAiValues pV in allPossibleValues)
            {
                if (pV.Key == key)
                {
                    return pV;
                }
            }
            return null;
        }
        
    }
}
