using System;
using System.Collections.Generic;
using System.Text;

namespace FM
{
    /// <summary>
    /// Uskladnuje kardinalitu pre pouzitie v dcerskych triedach
    /// </summary>
    [Serializable]
    public class CardinalityHolder : DNode
    {
        /// <summary>
        /// Objekt s kardinalitou tohto uzla (triedy odvoden od DNode interpretuj kardinalitu kad svojim spsobom).
        /// </summary>
        private NodeCardinality cardinality;

        /// <summary>
        /// Docasny konstruktor. Je potrebne ho pred dokoncenim projektu zmazat!
        /// </summary>
        public CardinalityHolder()
            : base(null, "")
        {
            cardinality = new NodeCardinality();
        }

        /// <summary>
        /// Konstruktor. ... //TODO
        /// </summary>
        /// <param name="parent"></param>
        /// <param name="ID"></param>
        public CardinalityHolder(TreeNode parent, String ID)
			: base(parent, ID)
		{
            cardinality = new NodeCardinality();
        }

        /// <summary>
        /// Zska odkaz na objekt s kardinalitou uzla.
        /// </summary>
        public NodeCardinality Cardinality
        {
            get
            {
                return cardinality;
            }
        }

        /// <summary>
        /// Kopruje vrchol aj s dtami kardinality.
        /// </summary>
        /// <returns>Vrti novovytvoren vrchol.</returns>
        public override TreeNode Clone()
        {
            CardinalityHolder copy = (CardinalityHolder)base.Clone();
            copy.cardinality = cardinality.Clone();
            return (TreeNode)copy;
        }

        /// <summary>
        /// Zhodnot, i treba oznai Feature ako selected pri vytvaran intancie.
        /// </summary>
        public virtual void ResolveFeatureSelection()
        {
            foreach (CardinalityHolder item in (System.Collections.ArrayList)Children.Clone())
            {
                if ((item.GetType() == typeof(DFeature))
                 || (item.GetType() == typeof(DGroup)))
                    item.ResolveFeatureSelection();
            }
        }
    }
}
