using System;
using System.Collections;
using System.Collections.Generic;
using System.Text;

namespace FM
{
    /// <summary>
    /// Trieda DefaultDepenencyRules obsahuje pravidla pre vytvaranie intanci.
    /// </summary>
    [Serializable]
    public class DefaultDependencyRules
    {
        private ArrayList rules;
        private Diagram diagram;

        /// <summary>
        /// Kontruktor vytvra objekt tried DefaultDependencyRules.
        /// </summary>
        /// <param name="diagram">Vstupnm parametrom je diagram, na ktor sa maj tieto obmedzenia aplikova.</param>
        public DefaultDependencyRules(Diagram diagram)
        {
            this.diagram = diagram;
            rules = new ArrayList();
        }
    
        
        
        /// <summary>
        /// Public metda, ktor aplikuje pravidl z rules na diagram.
        /// </summary>
        /// <param name="root"></param>
        public void Apply(DNode root)
        {
            throw new System.NotImplementedException();
        }
/*       
        /// <summary>
        /// Public metda, ktor zabezpeuje pridanie pravidla, zapsanho v textovom reazci medzi pravidl.
        /// </summary>
        /// <param name="expression">Vstupnm parametrom je textov reazec expression.</param>
        public void AddRule(String expression)
        {
            Expression e = new Expression(GetNewid(), expression);
            if (e.ParseExpression())
            {
                rules.Add(e);
            }
        }
*/

        /// <summary>
        /// Public metda RemoveRule odstrni pravidlo na zklade id.
        /// </summary>
        /// <param name="rule_id">Vstupmm parametrom je identifikan slo pravidla, ktor sa m odstrni.</param>
        /// <returns>Pokia bolo zmazvanie spen vrti sa hodnota true, inak false.</returns>
        public bool RemoveRule(int rule_id)
        {
            foreach (Expression e in rules)
            {
                if (e.GetID == rule_id)
                {
                    rules.Remove(e);
                    return true;
                }
            }
            return false;
        }

        /// <summary>
        /// Metda sprstupn pravidlo Poda identifikanho sla.
        /// </summary>
        /// <param name="rule_id">Vstupnm parametrom je identifikan slo pravidla ktor sa m sprstupni.</param>
        /// <returns>Vstupom je text previdla so zadanm identifikanm slom, alebo null, pokia takto pravidlo nebolo njden</returns>
        public String GetRule(int rule_id)
        {
            foreach (Expression e in rules)
            {
                if (e.GetID == rule_id)
                {
                    return e.exp;
                }
            }
            return null;
        }

        /// <summary>
        /// Metda vracia vetky pravidl vztahujce sa na diagram.
        /// </summary>
        /// <returns>Vstupom je ArrayList vetkch pravidiel</returns>
        public ArrayList GetAllRules()
        {
            return rules;
        }

        /// <summary>
        /// Privatna metda GetNewid m na starosti prideoanie identifikanch sel id novm pravidlm.
        /// </summary>
        /// <returns>Vracia sa id novho pravidla.</returns>
        private int GetNewid()
        {
            int id = 0;
            return id;
        }

        /// <summary>
        /// Vytvra kpiu objektu.
        /// </summary>
        /// <param name="diagram">Diagram na ktor bude kpia naviazan.</param>
        /// <returns>Vrti vytvoren kpiu.</returns>
        public DefaultDependencyRules Clone(Diagram diagram)
        {
            DefaultDependencyRules copy = (DefaultDependencyRules)this.MemberwiseClone();
            copy.diagram = diagram;
            copy.rules = new ArrayList(); // TODO...
            return copy;
        }
    }
}
