using System;
using System.Collections;
using System.Collections.Generic;
using System.Text;

namespace FM
{
    /// <summary>
    /// Mnoina nastavitench hodnt.
    /// </summary>
    [Serializable]
    public class PossibleAiValues
    {
        private String key;
        /// <summary>
        /// Vrti identifiktor mnoiny nastavitench hodnt.
        /// </summary>
        public String Key
        {
            get { return key; }
        }
        private ArrayList possibleValues;
        /// <summary>
        /// Vrti referenciu na pole obsahujce nastaviten hodnoty.
        /// </summary>
        public ArrayList PossibleValues
        {
            get { return possibleValues; }
        }

        /// <summary>
        /// Kontruktor mnoiny nastavitench hodnt pre dan k. 
        /// </summary>
        /// <param name="key">Kl pre mnoinu nastavitench hodnt.</param>
        public PossibleAiValues(String key)
        {
            this.key = key;
            possibleValues = new ArrayList();
        }
        /// <summary>
        /// Prid nov hodnotu do mnoiny nastavitench hodnt, ak tam ete tak nie je.
        /// </summary>
        /// <param name="value">Nov hodnota pridvan do mnoiny nastavitench hodnt.</param>
        /// <returns>True - hodnota bola pridan, False - inak.</returns>
        public bool AddValueToSet(String value)
        {
            if (!IsValueInSet(value))
            {
                possibleValues.Add(value);
                return true;
            }
            else
            {
                return false;
            }
        }
        /// <summary>
        /// Odstrni hodnotu z mnoiny nastavitench hodnt, ktor tam vak mus existova.
        /// </summary>
        /// <param name="value">Hodnota odstraovan z mnoiny nastavitench hodnt.</param>
        /// <returns>True - hodnota bola odstrnen, False - inak</returns>
        public bool RemoveValueFromSet(String value)
        {
            if (IsValueInSet(value))
            {
                possibleValues.Remove(value);
                return true;
            }
            else
            {
                return false;
            }
        }
        /// <summary>
        /// Testuje, i hodnota existuje v mnoine nastavitench hodnt.
        /// </summary>
        /// <param name="value">Testovan hodnota.</param>
        /// <returns>True - ak hodnota je v mnoine, False - hodnota nie je v mnoine.</returns>
        public bool IsValueInSet(String value)
        {
            return possibleValues.Contains(value);
        }
        /// <summary>
        /// Funkcia vracajca poet hodnt v mnoine nastavitench hodnt.
        /// </summary>
        /// <returns>Poet hodnt v mnoine nastavitench hodnt.</returns>
        public int PossibleValuesCount()
        {
            return possibleValues.Count;
        }
    }
}
