using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace FM
{
    /// <summary>
    /// Formulr uren na manaovanie hodnotovch (selectable) dodatonch informci.
    /// </summary>
    public partial class AiForm2 : Form
    {
        AllPossibleAiValues aPVSpecific;
        TreeView treeView;

        String nodName;
        AiItems aIItemsSpecific;
        /// <summary>
        /// Kontruktor pre formulr uren na manaovanie hodnotovch (selectable) dodatonch informci.
        /// </summary>
        /// <param name="aPVSpecific">Referencie na vetky mon Ai hodnoty.</param>
        /// <param name="nodName">Nzov uzla.</param>
        /// <param name="aIItemsSpecific">Zoznam doplujcich informacii.</param>
        /// <param name="treeView">Grafick stromov pohad, do ktorho sa pridvaj AI.</param>
 
        public AiForm2(AllPossibleAiValues aPVSpecific, String nodName, AiItems aIItemsSpecific, TreeView treeView)
        {
            InitializeComponent();

            this.aPVSpecific = aPVSpecific;
            this.nodName = nodName;
            this.aIItemsSpecific = aIItemsSpecific;
            this.treeView = treeView;
        }

        private void Submit_Click(object sender, EventArgs e)
        {
            

        }

        private void Cancel_Click(object sender, EventArgs e)
        {

        }

        private void AddPosValue_Click(object sender, EventArgs e)
        {    
            if(this.selectableAiName.Text.Equals(""))
                return;

            if (this.selectableAiValue.Text.Equals(""))
                return;
  //          MessageBox.Show(nodName);

            /*
            if ((selectableAiName.Text == "BindingTime") || (selectableAiName.Text == "InstantiationTime"))
            {
                MessageBox.Show("AiItem name was reserved by system! Choose another.");
                return;
            }
            */
            if(aIItemsSpecific.AddAi(selectableAiName.Text, true, aPVSpecific))
                treeView.SelectedNode.Nodes.Add(selectableAiName.Text);

            aIItemsSpecific.GetAi(selectableAiName.Text).Description = selectableAiDescription.Text;

            if (aIItemsSpecific.GetAi(selectableAiName.Text).AddValueToSet(selectableAiValue.Text))
            {
                selectableAiPV.Items.Add(selectableAiValue.Text);
            }

            selectableAiName.ReadOnly = true;
            selectableAiValue.Text = "";

            selectableAiValue.Focus();
        }

        private void SetPV_Click(object sender, EventArgs e)
        {
            if (this.selectableAiName.Text.Equals(""))
                return;

            if (aIItemsSpecific.GetAi(selectableAiName.Text) != null)
            {
                if (selectableAiPV.SelectedIndices.Count > 0)
                {
//                  selectableAiCV.Text = selectableAiPV.SelectedItem.ToString();
                    aIItemsSpecific.GetAi(selectableAiName.Text).CurrentValue = selectableAiPV.SelectedItem.ToString();
                }
            }
        }

        private void RemPosValue_Click(object sender, EventArgs e)
        {
            if (this.selectableAiName.Text.Equals(""))
                return;

            if (aIItemsSpecific.GetAi(selectableAiName.Text) != null)
            {
                if (selectableAiPV.SelectedIndices.Count > 0)
                {
                    String remPV = selectableAiPV.SelectedItem.ToString();

                    if (aIItemsSpecific.GetAi(selectableAiName.Text).RemoveValueFromSet(remPV))
                    {
                        selectableAiPV.Items.Remove(remPV);

                        if (aIItemsSpecific.GetAi(selectableAiName.Text).CurrentValue == remPV)
                        {
                            aIItemsSpecific.GetAi(selectableAiName.Text).CurrentValue = "";
//                            selectableAiCV.Text = "";
                        }
                    }
                }
                else
                    MessageBox.Show("Possible Value not selected!");
            } 
        }

    }
}