using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace FM
{
    /// <summary>
    /// Formulr uren na menenie default hodnt dodatonch informci.
    /// </summary>
    public partial class AiForm4 : Form
    {
        AiItems aiItems;
        AllPossibleAiValues aPVspecific;

        /// <summary>
        /// Kontruktor pre formulr uren na menenie default hodnt dodatonch informci.
        /// </summary>
        /// <param name="aiItems">Zoznam doplujcich informacii.</param>
        /// <param name="aPVspecific">Referencie na vetky mon Ai hodnoty.</param>
        public AiForm4(AiItems aiItems, AllPossibleAiValues aPVspecific)
        {
            InitializeComponent();

            this.aiItems = aiItems;
            this.aPVspecific = aPVspecific;

        }

        private void AiForm4_Load(object sender, EventArgs e)
        {
            // Pociatocne inicializovanie laveho listboxu

            // Pridame do listboxu selectable AiItem
            for (int i = 0; i < aPVspecific.AllPossibleValues.Count; i++)
            {
                PossibleAiValues possibleAiValues = (PossibleAiValues) aPVspecific.AllPossibleValues[i];
                AiItemslistBox.Items.Add(possibleAiValues.Key);
            }
            
            // Pridame do listboxu aj textove AiItem
            for (int i = 0; i < aiItems.aiItems.Count; i++)
            {
                AiItem aiItem = (AiItem)aiItems.aiItems[i];
                if(!aiItem.IsSelectable())
                    AiItemslistBox.Items.Add(aiItem.Key);
            }
           
             
        }

        private void AiItemslistBox_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (AiItemslistBox.SelectedIndices.Count > 0)
            {
  
                // Najskor vymazat vsetky hodnoty z ListBoxu
                PVlistBox.Items.Clear();
                
                String selectedAiText = AiItemslistBox.SelectedItem.ToString();

                // Selectable AiItem
                if (aiItems.GetAi(selectedAiText).IsSelectable())
                {
                    PossibleAiValues possibleAiValues = aPVspecific.GetReferenceToKey(selectedAiText);

                    DVtextBox.Text = aiItems.GetAi(selectedAiText).CurrentValue;
                    AiItemDescription.Text = aiItems.GetAi(selectedAiText).Description;

                    for (int i = 0; i < possibleAiValues.PossibleValues.Count; i++)
                    {
                        PVlistBox.Items.Add(possibleAiValues.PossibleValues[i]);
                    }
                }

                // Textual AiItem
                else
                {
                    DVtextBox.Text = aiItems.GetAi(selectedAiText).CurrentValue;
                    AiItemDescription.Text = aiItems.GetAi(selectedAiText).Description;
                    DVtextBox.ReadOnly = false;
                }
            }
        }

        private void buttonChangeDV_Click(object sender, EventArgs e)
        {
            if (AiItemslistBox.SelectedIndices.Count <= 0)
                return;

            String selectedAiText = AiItemslistBox.SelectedItem .ToString();

            if(aiItems.GetAi(selectedAiText) == null)
                return;

            // Selectable
            if (PVlistBox.SelectedIndices.Count > 0)
            {
                String selectedPVText = PVlistBox.SelectedItem.ToString();
                if (aiItems.GetAi(selectedAiText).IsValueInSet(selectedPVText))
                {
                    aiItems.GetAi(selectedAiText).SetAi(selectedPVText);
                    DVtextBox.Text = selectedPVText;
                }

            }
            // Textual 
            else if (!aiItems.GetAi(selectedAiText).IsSelectable())
            {
                aiItems.GetAi(AiItemslistBox.SelectedItem.ToString()).SetAi(DVtextBox.Text);
                MessageBox.Show("Value of textual AiItem was changed.");
            }
            else
                MessageBox.Show("Select one item from the Possible Value ListBox first!"); 

        }

        private void label4_Click(object sender, EventArgs e)
        {

        }
    }
}