using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace FM.forms
{
    /// <summary>
    /// Trieda zobrazujca informcie o validite instancie.
    /// </summary>
    public partial class ConstraintsValidateForm : Form
    {
        //private String result = null;
        /// <summary>
        /// Potadlo chybovch vrazov.
        /// </summary>
        private int ERR_counter = 0;
        /// <summary>
        /// Potadlo korektnch vrazov.
        /// </summary>
        private int OK_counter = 0;
        /// <summary>
        /// Potadlo nesplnench vrazov.
        /// </summary>
        private int NA_counter = 0;
        /// <summary>
        /// Potadlo neznmych vrazov.
        /// </summary>
        private int UN_counter = 0;
        /// <summary>
        /// Nastav sa sem vazobn diagram
        /// </summary>
        private Diagram diagram = null;

        /// <summary>
        /// Kontuktor nainicializuje hodnoty.
        /// </summary>
        /// <param name="diagram">Vstupom je vzobn diagram.</param>
        public ConstraintsValidateForm(Diagram diagram)
        {
            this.diagram = diagram;
            InitializeComponent();
        }

        private void ConstraintsValidateForm_Load(object sender, EventArgs e)
        {
            this.ValidateConstraints();
        }

        /// <summary>
        /// Metda spracuje validciu obmedzen a zobraz ich spolone s vsledkami do listView1 a status baru.
        /// </summary>
        private void ValidateConstraints()
        {
            listView1.Items.Clear();
            //result = "";
            OK_counter = 0;
            NA_counter = 0;
            UN_counter = 0;
            ERR_counter = 0;

            if (diagram == null)
            {
                //result = "Error: INCORECT NODE WAS SELECTED AS ROOT FOR CONSTRAINTS!";
                MessageBox.Show("Error: INCORECT NODE WAS SELECTED AS ROOT FOR CONSTRAINTS!");
                this.Close();
            }
            else
            {
                toolStripProgressBar1.Maximum = diagram.Constraints.GetAllConstraints().Count;
                foreach (Expression exp in diagram.Constraints.GetAllConstraints())
                {
                    String s = exp.ParseExpression(diagram);
                    toolStripProgressBar1.Visible = true;
                    toolStripProgressBar1.Increment(1);

                    if (s == "0")
                    {
                        ListViewItem l = new ListViewItem(new string[] { exp.exp, "Correct: NOT accomplished" });
                        l.Font = new Font(l.Font, l.Font.Style | FontStyle.Italic);
                        listView1.Items.Add(l);
                        NA_counter++;
                    }
                    else if (s == "1")
                    {
                        ListViewItem l = new ListViewItem(new string[] { exp.exp, "Correct: OK" });
                        l.Font = new Font(l.Font, l.Font.Style | FontStyle.Regular);
                        listView1.Items.Add(l);
                        OK_counter++;
                    }
                    else if (s == "2")
                    {
                        ListViewItem l = new ListViewItem(new string[] { exp.exp, "Correct: unknown yet" });
                        l.Font = new Font(l.Font, l.Font.Style | FontStyle.Italic);
                        listView1.Items.Add(l);
                        UN_counter++;
                        
                    }
                    else if (s.Trim().StartsWith("3"))
                    {
                        s = s.Trim().Substring(1);
                        ListViewItem l = new ListViewItem(new string[] { exp.exp, s.Trim() });
                        l.Font = new Font(l.Font, l.Font.Style | FontStyle.Bold);
                        listView1.Items.Add(l);
                        ERR_counter++;

                    }
                    else
                    {
                        ListViewItem l = new ListViewItem(new string[] { exp.exp, "Error: Unexpected error ocured" });
                        l.Font = new Font (l.Font, l.Font.Style | FontStyle.Bold);
                        listView1.Items.Add(l);
                    }                    
                }
                toolStripProgressBar1.Visible = false;
                this.toolStripStatusLabel1.Text = "STATUS: ";
                if( (NA_counter == 0) && (UN_counter == 0) && (ERR_counter == 0) )
                    this.toolStripStatusLabel2.Text = "Instance is VALID !";
                else
                    if ((UN_counter > 0) && (ERR_counter == 0) &&(NA_counter ==0))
                    {
                        this.toolStripStatusLabel2.Text = "Instance status is UNKNOWN !";
                    }
                    else
                    {
                        this.toolStripStatusLabel2.Text = "Insrtance is NOT VALID !";
                    }
                this.toolStripStatusLabel3.Text = "TOTAL: ";
                this.toolStripStatusLabel4.Text = diagram.Constraints.GetAllConstraints().Count.ToString();
                this.toolStripStatusLabel5.Text = " OK: ";
                this.toolStripStatusLabel6.Text = OK_counter.ToString() ;
                this.toolStripStatusLabel7.Text = " NOT ACCOMPLISHED: ";
                this.toolStripStatusLabel8.Text = NA_counter.ToString();
                this.toolStripStatusLabel9.Text = " UNKNOWN: ";
                this.toolStripStatusLabel10.Text = UN_counter.ToString();
                this.toolStripStatusLabel11.Text = " ERROR: ";
                this.toolStripStatusLabel12.Text = ERR_counter.ToString();
            }
        }

        private void editToolStripMenuItem_Click(object sender, EventArgs e)
        {
            forms.ConstraintsMainForm f = new ConstraintsMainForm(diagram);
            if (listView1.SelectedItems.Count > 0)
            {
                ListViewItem l = listView1.SelectedItems[0];

                f.ChangeConstraint(l.Text);
                f.ShowDialog();
                this.ValidateConstraints();
            }
        }

        private void validateToolStripMenuItem_Click(object sender, EventArgs e)
        {
            this.ValidateConstraints();
        }

        private void listView1_DoubleClick(object sender, EventArgs e)
        {
            /*
            forms.ConstraintsMainForm f = new ConstraintsMainForm(diagram);
            if (listView1.SelectedItems.Count > 0)
            {
                ListViewItem l = listView1.SelectedItems[0];

                f.ChangeConstraint(l.Text);
                f.ShowDialog();
                this.ValidateConstraints();
            }
            */
        }


    }
}