using System;
using System.IO;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Collections;
using System.Runtime.Serialization.Formatters.Soap;

namespace FM
{
    /// <summary>
    /// Hlavn okno programu.
    /// </summary>
    public partial class Form1 : Form
    {
        Project project;
       
        // Tieto 3 potrebujem
        AllPossibleAiValues aPVProject;
        AllPossibleAiValues aPVDiagram;
        AllPossibleAiValues aPVFeature;

        NodeAiTemplates nodeAiTemplate;

        /// <summary>
        /// Kontroln premenn pridan kvli sprvnemu handlovaniu zakrtnutia 
        /// "nezakrtnutench" checkboxov pri konceptoch, resp. pri uzloch, ktor nie
        /// s typu features. Bez nej sa ned zabrni vzniku nekoneneho cyklu.
        /// </summary>
        private bool doNotHandleAfterCheck;

        /// <summary>
        /// Kontruktor okna.
        /// </summary>
        public Form1()
        {
            InitializeComponent();

            //Inicilne je tto premenna nastaven na false:
            this.doNotHandleAfterCheck = false;
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            project = new Project();

            aPVProject = new AllPossibleAiValues();
            aPVDiagram = new AllPossibleAiValues();
            aPVFeature = new AllPossibleAiValues();

            nodeAiTemplate = null;

            InitializeAiTemplateWithoutDialog();
            project.ShowTreeControl(treeView1);
        }

        /// <summary>
        /// Metda povoli alebo zake poloku kontextovho menu.
        /// </summary>
        /// <param name="contextMenu">Ovladac prvok kontextovho menu</param>
        /// <param name="contextMenuItem">Nzov poloky v menu</param>
        /// <param name="enable">pecifikuje, i povoli alebo zakza poloku</param>
        private void enableContextMenuItem(ContextMenuStrip contextMenu, string contextMenuItem, bool enable)
        {
            ToolStripItem[] tmp = contextMenu.Items.Find(contextMenuItem, false);
            if (tmp.Length > 0)
            {
                tmp[0].Enabled = enable;
            }
        }

        private void treeView1_AfterSelect(object sender, TreeViewEventArgs e)
        {
            TreeNode selectedNode = (TreeNode)treeView1.SelectedNode.Tag;
            textBox1.Text = selectedNode.DumpPublic();

            // Na property grid kasleme.. skoda :(
            //propertyGrid1.SelectedObject = selectedNode;

            DNode selNode = (DNode)treeView1.SelectedNode.Tag;

            if (selNode.GetType() == typeof(Project))
            {
                this.ContextMenuStrip = projectContextMenu;
                //((Project)treeView1.SelectedNode.Tag).ImportAiTemplate();
            }

            // Povolime vsetko:
            this.enableContextMenuItem(diagramContextMenu, "addGroup", true);
            this.enableContextMenuItem(diagramContextMenu, "addFeature", true);
            this.enableContextMenuItem(diagramContextMenu, "properties", true);
            this.enableContextMenuItem(diagramContextMenu, "removeToolStripMenuItem", true);

            // Zakazeme kopirovanie diagramu a vytvorenie instancii (povolime to v neskor iba pre diagram):
            this.enableContextMenuItem(diagramContextMenu, "createCopyToolStripMenuItem", false);
            this.enableContextMenuItem(diagramContextMenu, "makeinstanceToolStripMenuItem", false);

            if (selNode.GetType() == typeof(Diagram))
            {
                
                // textBox1.Text = ((TreeNode)treeView1.SelectedNode.Tag).DumpPublic();

                // Povolime kopirovanie diagramu a vytvorenie instancii
                this.enableContextMenuItem(diagramContextMenu, "createCopyToolStripMenuItem", true);
                this.enableContextMenuItem(diagramContextMenu, "makeinstanceToolStripMenuItem", true);
                             
                this.ContextMenuStrip = diagramContextMenu;
         
                // Povolime properties:
                this.enableContextMenuItem(diagramContextMenu, "properties", true);

                if (((Diagram)selNode).IsInstance)
                    this.enableContextMenuItem(diagramContextMenu, "constraintsToolStripMenuItem", false);
                else
                    this.enableContextMenuItem(diagramContextMenu, "constraintsToolStripMenuItem", true);

				this.enableContextMenuItem(diagramContextMenu, "validateCardinalityDependencies", true);
				if (((Diagram)selNode).IsInstance)
                {
                    this.enableContextMenuItem(diagramContextMenu, "validateInstanceToolStripMenuItem", true);
                }
                else
                {
                    this.enableContextMenuItem(diagramContextMenu, "validateInstanceToolStripMenuItem", false);
                }
            }

            if (selNode.GetType() == typeof(DFeature))
            {
                /*
                if (fTemplate)
                {
                    ((DFeature)treeView1.SelectedNode.Tag).ImportAiTemplate();
                    textBox1.Text = ((TreeNode)treeView1.SelectedNode.Tag).DumpPublic();
                    fTemplate = false;
                }
                */
                this.ContextMenuStrip = diagramContextMenu;

                this.enableContextMenuItem(diagramContextMenu, "changeAIDefaultValueToolStripMenuItem", true);
                this.enableContextMenuItem(diagramContextMenu, "validateInstanceToolStripMenuItem", false);
                this.enableContextMenuItem(diagramContextMenu, "validateCardinalityDependencies", false);
            }

            if (selNode.GetType() == typeof(DGroup))
            {
                this.ContextMenuStrip = diagramContextMenu;

                // Zakazeme pridanie skupiny (pod skupinou moze byt len feature):
                this.enableContextMenuItem(diagramContextMenu, "addGroup", false);

                // Zakazeme zmenu AI Default Value pre skupiny
                this.enableContextMenuItem(diagramContextMenu, "changeAIDefaultValueToolStripMenuItem", false);

                this.enableContextMenuItem(diagramContextMenu, "validateInstanceToolStripMenuItem", false);
                this.enableContextMenuItem(diagramContextMenu, "validateCardinalityDependencies", false);
            }

            // Ak ide o instaciu, alebo diagram obsahujuci instanciu, nedaju sa robit zmeny:
            if (this.ContextMenuStrip == diagramContextMenu)
            {
                Diagram dgr;
                if (selNode.GetType() == typeof(Diagram))
                {
                    dgr = (Diagram)selNode;
                }
                else
                {
                    dgr = selNode.Diagram;
                }
                    
                if (dgr.IsInstance || dgr.HasInstance)
                {
                    this.enableContextMenuItem(diagramContextMenu, "addGroup", false);
                    this.enableContextMenuItem(diagramContextMenu, "addFeature", false);

                    if (selNode.GetType() != typeof(Diagram))
                    {
                        this.enableContextMenuItem(diagramContextMenu, "removeToolStripMenuItem", false);
                    }
                }
            }

        }

        private void textBox1_TextChanged(object sender, EventArgs e)
        {

        }

        private void exitToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Application.Exit();
        }

        private void treeView1_MouseHover(object sender, EventArgs e)
        {
            statusBar.Text = "Right click on tree nodes for more options.";
        }

        private void treeView1_NodeMouseClick(object sender, TreeNodeMouseClickEventArgs e)
        {
            treeView1.SelectedNode = treeView1.GetNodeAt(treeView1.PointToClient(Cursor.Position));

            if(e.Button == MouseButtons.Right)
            {
                treeView1.SelectedNode = treeView1.GetNodeAt (e.X ,e.Y );
            }
        }

        private void addGroup_Click(object sender, EventArgs e)
        {
            
        }

        private void addDiagramToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Project tmp = (Project)treeView1.SelectedNode.Tag; 
            Diagram newDiagram = tmp.AddDiagram("diagram");

            SetDiagramName dlgg = new SetDiagramName(newDiagram.Name);
            if (dlgg.ShowDialog() == DialogResult.OK)
            {
                newDiagram.SetID(dlgg.MyName);
            }

            newDiagram.ShowTreeControl(treeView1.SelectedNode.Nodes);
        }

        private void featureContextMenu_Opening(object sender, CancelEventArgs e)
        {
        }

        private void addGroup_Click_1(object sender, EventArgs e)
        {
            PropertiesForm propertiesForm = new PropertiesForm((DNode)treeView1.SelectedNode.Tag, false);
            if (propertiesForm.ShowDialog() == DialogResult.OK)
            {
                string name = propertiesForm.name.Text;

                DNode selectedNode = (DNode)treeView1.SelectedNode.Tag;
                DGroup newNode = (DGroup)selectedNode.AddNode("group", name);

                newNode.Cardinality.SetCardinality(propertiesForm.cardMin, propertiesForm.cardMax);
                newNode.ShowTreeControl(treeView1.SelectedNode.Nodes);
            }
        }

        private void addFeatureToolStripMenuItem_Click(object sender, EventArgs e)
        {
            PropertiesForm propertiesForm = new PropertiesForm((DNode)treeView1.SelectedNode.Tag, true);
            if (propertiesForm.ShowDialog() == DialogResult.OK)
            {
                string name = propertiesForm.name.Text;

                DNode selectedNode = (DNode)treeView1.SelectedNode.Tag;
                DFeature newNode = (DFeature)selectedNode.AddNode("feature", name);

                newNode.Cardinality.SetCardinality(propertiesForm.cardMin, propertiesForm.cardMax);
                newNode.ShowTreeControl(treeView1.SelectedNode.Nodes);
                textBox1.Text = ((TreeNode)treeView1.SelectedNode.Tag).DumpPublic();
            }
        }
        /// <summary>
        /// Inicializovanie ablny s dodatonmi informciami.
        /// </summary>
        public void InitializeAiTemplate()
        {
            AiForm1 dialogAiTemplate = new AiForm1(aPVProject, aPVDiagram, aPVFeature);
            dialogAiTemplate.ShowDialog();
            project.NodeAiTemplates = nodeAiTemplate = dialogAiTemplate.NodeAiTemplates;
            project.ImportAiTemplate();
            project.BindingTime = dialogAiTemplate.BindingTimeAiItem;

            ToolStripItem[] tmp = settingsToolStripMenuItem.DropDownItems.Find("aItemplatesToolStripMenuItem", false);
                
            if (tmp.Length > 0)
            {
                tmp[0].Enabled = false;
            }

            //this.enableContextMenuItem(settingsToolStripMenuItem, "aItemplatesToolStripMenuItem", false);

        }
        /// <summary>
        /// Automatick inicializovanie ablny s dodatonmi informciami bez pouzivateskho dialgu.
        /// </summary>
        public void InitializeAiTemplateWithoutDialog()
        {
            AiForm1 dialogAiTemplate = new AiForm1(aPVProject, aPVDiagram, aPVFeature);
            dialogAiTemplate.Show();
            dialogAiTemplate.Close();

            project.NodeAiTemplates = nodeAiTemplate = dialogAiTemplate.NodeAiTemplates;
            project.ImportAiTemplate();
            project.BindingTime = dialogAiTemplate.BindingTimeAiItem;

        }

        /// <summary>
        /// Inicializan funkcia pre zmenu default hodnt dodatonej informcie.
        /// </summary>
        /// <param name="selectedNode">Konkrtny vybran uzol v strome.</param>
        /// <param name="aPVspecific">Referencie na vetky mon Ai hodnoty.</param>
        public void ChangeDefaultValueInit(DNode selectedNode, AllPossibleAiValues aPVspecific)
        {
            //AiItems aiItems = TEMPLATE.DiagramAiItems;          //selectedNode.AiItems;
            //aPVspecific = aPVDiagram;

            AiItems aiItems = selectedNode.AiItems;

            /************************* PRE TESTOVACIE UCELY *****************************
            AiItems aiItems = new AiItems();
            AllPossibleAiValues aPV = new AllPossibleAiValues();
            
            aiItems.AddAi("Farba", true, aPV);
            aiItems.GetAi("Farba").AddValueToSet("modra");
            aiItems.GetAi("Farba").AddValueToSet("cervena");
            aiItems.GetAi("Farba").AddValueToSet("zelena");

            aiItems.GetAi("Farba").SetAi("zelena");

            aiItems.AddAi("Priorita", true, aPV);
            aiItems.GetAi("Priorita").AddValueToSet("vysoka");
            aiItems.GetAi("Priorita").AddValueToSet("stredna");
            aiItems.GetAi("Priorita").AddValueToSet("nizka");
            
            /****************************************************************************/
            AiForm4 aiForm4 = new AiForm4(aiItems, aPVspecific);
            
            // V pripade diagramu a instancie
            if (selectedNode.GetType() == typeof(Diagram))
            {
                if (((Diagram)selectedNode).IsInstance)
                {
                    aiForm4.Text = "Additional Information Value Change";
                    
                }
            }
            aiForm4.ShowDialog();
        }

        private void constraintsToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Diagram tmp;
            if (treeView1.SelectedNode.Tag.GetType() == typeof(Diagram))
                tmp = (Diagram)treeView1.SelectedNode.Tag;
            else
                tmp = ((DNode)treeView1.SelectedNode.Tag).Diagram;

            if (tmp.isConcept())
            {
                forms.ConstraintsMainForm f = new FM.forms.ConstraintsMainForm(tmp);
                f.Show();
            }

        }
        /*
        private void button1_Click(object sender, EventArgs e)
        {
            project.GetDiagram("diagram1").CreateInstance();
            project.ShowTreeControl(treeView1);
        }

        private void button2_Click_1(object sender, EventArgs e)
        {
            project.GetDiagram("diagram1").CloneDiagram();
            project.ShowTreeControl(treeView1);
        }

        private void contextMenuStrip1_Opening(object sender, CancelEventArgs e)
        {

        }
        */

        private void propertiesToolStripMenuItem1_Click(object sender, EventArgs e)
        {
            if (treeView1.SelectedNode.Tag.GetType() == typeof(DFeature))
            {
                DFeature selectedNode = (DFeature)treeView1.SelectedNode.Tag;
                PropertiesForm propertiesForm = new PropertiesForm(selectedNode, selectedNode.Name, selectedNode.Cardinality.Min, selectedNode.Cardinality.Max, true);
                if (propertiesForm.ShowDialog() == DialogResult.OK)
                {
                    selectedNode.Cardinality.SetCardinality(propertiesForm.cardMin, propertiesForm.cardMax);
                    if (selectedNode.Diagram.IsInstance)
                    {
                        selectedNode.Selected = propertiesForm.featureSelected.Checked;
                    }
                }
                if (selectedNode.Diagram.IsInstance)
                {
                    selectedNode.Selected = propertiesForm.featureSelected.Checked;
                }
                else
                {
                    selectedNode.SetID(propertiesForm.name.Text);
                }

                treeView1.SelectedNode.Text = selectedNode.Id;
                textBox1.Text = selectedNode.DumpPublic();
			}

            if (treeView1.SelectedNode.Tag.GetType() == typeof(DGroup))
            {
                DGroup selectedNode = (DGroup)treeView1.SelectedNode.Tag;
                PropertiesForm propertiesForm = new PropertiesForm(selectedNode, selectedNode.Name, selectedNode.Cardinality.Min, selectedNode.Cardinality.Max, false);
                if (propertiesForm.ShowDialog() == DialogResult.OK)
                {
                    selectedNode.Cardinality.SetCardinality(propertiesForm.cardMin, propertiesForm.cardMax);
                }

                treeView1.SelectedNode.Text = selectedNode.Name;
				textBox1.Text = selectedNode.DumpPublic();
			}

            if (treeView1.SelectedNode.Tag.GetType() == typeof(Diagram))
            {
                String heading = "Edit Diagram Name";
                if (((Diagram)treeView1.SelectedNode.Tag).IsInstance) heading = "Edit Instance Name";
                SetDiagramName dlgg = new SetDiagramName(((Diagram)treeView1.SelectedNode.Tag).Name, heading);
                if (dlgg.ShowDialog() == DialogResult.OK)
                {
                    ((Diagram)treeView1.SelectedNode.Tag).SetID(dlgg.MyName);
                }

                treeView1.SelectedNode.Text = ((Diagram)treeView1.SelectedNode.Tag).Id;
                textBox1.Text = ((Diagram)treeView1.SelectedNode.Tag).DumpPublic();
            }
        }

        /// <summary>
        /// Metda obsluhuje chovanie po zakrtnut/odkrtnut checkboxu pri uzle stromu.
        /// V prpade, e ide o uzol, ktor nie je feature, alebo ide o feature v koncepte,
        /// metda nedovol zakrtn checkbox. Kee sa v tomto prpade nastavuje vlastnos
        /// uzla stromu ovldacieho prvku TreeView (TreeNode), automaticky sa pri nastaven
        /// vol znova rekurzvne tto metda, m vznikal nekonn cyklus. Na zabrnenie jeho
        /// vzniku je pouit pomocn premenn doNotHandleAfterCheck, ktor sa v prpade 
        /// umelho odkrtnutia checkboxu nastav na true, m sa zabrni nekonenmu cyklu.
        /// V prpade, e ide o feature v intanci, metda nastav zrove intern hodnotu
        /// property Selected triedy DFeature poda toho, i bol checkbox prve zakrtnut
        /// alebo odkrtnut.
        /// </summary>
        /// <param name="sender">Objekt vyvolvajci udalos (nepouva sa)</param>
        /// <param name="e">Vyvolan udalos (nepouva sa)</param>
        private void treeView1_AfterCheck(object sender, TreeViewEventArgs e)
        {
            if (this.doNotHandleAfterCheck == true)
            {
                this.doNotHandleAfterCheck = false;
                return;
            }

            if ((e.Node.Tag.GetType() != typeof(DFeature)))
            {
                this.doNotHandleAfterCheck = true;
                e.Node.Checked = false;

                return;
            }

            DFeature selectedFeature = (DFeature)e.Node.Tag;
            if (selectedFeature.Diagram.isConcept() == true)
            {
                this.doNotHandleAfterCheck = true;
                e.Node.Checked = false;

                return;
            }

            if (selectedFeature.ReadOnly || selectedFeature.Unavailable)
            {
                this.doNotHandleAfterCheck = true;
                e.Node.Checked = selectedFeature.Selected;

                return;
            }

            if (e.Node.Checked == true && selectedFeature.Selected == false)
            {
                bool needRefresh = selectedFeature.Select();
                if (needRefresh)
                {
                    string path = selectedFeature.Parent.GetNodePathFromRoot();
                    System.Windows.Forms.TreeNode parentNode = selectedFeature.GetSelectNodeInTreeView(treeView1, path);

                    if (parentNode != null)
                    {
                        selectedFeature.LastAddedFeature.ShowTreeControl(parentNode.Nodes);
                    }
                }
            }
            else if (e.Node.Checked == false && selectedFeature.Selected == true)
            {
                selectedFeature.Deselect();
            }

            textBox1.Text = selectedFeature.DumpPublic();
        }

        private void diagramContextMenu_Opening(object sender, CancelEventArgs e)
        {

        }

        private void createCopyToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Diagram clonedDiagram = null;
            if (treeView1.SelectedNode.Tag.GetType() == typeof(Diagram))
            {
                clonedDiagram = ((Diagram)treeView1.SelectedNode.Tag).CloneDiagram();
            }
            else
            {
                return;
            }

            SetDiagramName dlgg = new SetDiagramName(clonedDiagram.Name);
            if (dlgg.ShowDialog() == DialogResult.OK)
            {
                clonedDiagram.SetID(dlgg.MyName);
            }

            clonedDiagram.ShowTreeControl(treeView1.SelectedNode.Nodes);
        }

        private void makeinstanceToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (treeView1.SelectedNode.Tag.GetType() != typeof(Diagram)) return;
			if (validateCardDependencies(treeView1.SelectedNode) == false)
			{
				MessageBox.Show("Apparently, there are some groups that contains less than one feature, which is considered invalid.\r\nThese groups were marked for you in the tree. Make sure you add some features under them or remove them from the diagram.", "Diagram invalid", MessageBoxButtons.OK, MessageBoxIcon.Warning);
				return;
			}

            AiItem bindingTime = project.BindingTime;
            AllPossibleAiValues bindingTimeValues = bindingTime.GetAllPossibleValues();
            ArrayList posibleBindingTimeValues = bindingTimeValues.AllPossibleValues;

            ArrayList bindingTimes = null;
            foreach (PossibleAiValues pbtv in posibleBindingTimeValues)
            {
                if (pbtv.Key == bindingTime.Key)
                {
                    bindingTimes = pbtv.PossibleValues;
                    break;
                }
            }

            string instTime = "";

			DNode selectedNode = (DNode)treeView1.SelectedNode.Tag;
			Diagram dgr;
			if (selectedNode.GetType() == typeof(Diagram))
			{
				dgr = (Diagram)selectedNode;
			}
			else
			{
				dgr = selectedNode.Diagram;
			}

			if (bindingTimes != null)
            {
                if (dgr.IsInstance)
                {
                    int a;
                    for (a = 0; a < bindingTimes.Count; a++)
                    {
                        if (dgr.NodeBindingTime.CurrentValue == (string)bindingTimes[a])
                        {
                            break;
                        }
                    }
                    bindingTimes.RemoveRange(0, a);
                }
            }

            InstationTimeSetter dlg = new InstationTimeSetter(dgr.Name + "Instance", bindingTimes);
            if (dlg.ShowDialog() == DialogResult.OK)
            {
                instTime = (string)dlg.instTime.SelectedItem;
            }
            else
            {
                return;
            }

            Diagram newInstance = null;
			newInstance = dgr.CreateInstance(instTime);
            newInstance.SetID(dlg.name.Text);

            newInstance.ShowTreeControl(treeView1.SelectedNode.Nodes);
			textBox1.Text = ((DNode)treeView1.SelectedNode.Tag).DumpPublic();
        }

        private void projectContextMenu_Opening(object sender, CancelEventArgs e)
        {

        }

        // Projekt
        private void aditionalInformationToolStripMenuItem_Click(object sender, EventArgs e)
        {
            ChangeDefaultValueInit((Project)treeView1.SelectedNode.Tag, aPVProject);
            textBox1.Text = ((TreeNode)treeView1.SelectedNode.Tag).DumpPublic();
            // Neviem naco by sa tu mal refreshovat treeview, ale radsej to necham zakomentovane.
            // Autor nech to pls pozrie.
            //project.ShowTreeControl(treeView1);
        }

        private void changeAIDefaultValueToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (treeView1.SelectedNode.Tag.GetType() == typeof(Diagram))
            {
                ChangeDefaultValueInit((Diagram)treeView1.SelectedNode.Tag, aPVDiagram);
            }
            else if (treeView1.SelectedNode.Tag.GetType() == typeof(DFeature))
            {
                ChangeDefaultValueInit((DFeature)treeView1.SelectedNode.Tag, aPVFeature);
            }
            textBox1.Text = ((TreeNode)treeView1.SelectedNode.Tag).DumpPublic();
            // Neviem naco by sa tu mal refreshovat treeview, ale radsej to necham zakomentovane.
            // Autor nech to pls pozrie.
            //project.ShowTreeControl(treeView1);

        }

        private void validateInstanceToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (treeView1.SelectedNode.Tag.GetType() == typeof(Diagram) )
            {
                Diagram tmp = (Diagram)treeView1.SelectedNode.Tag;
                if (tmp.IsInstance)
                {
                    forms.ConstraintsValidateForm f = new FM.forms.ConstraintsValidateForm(tmp);
                    f.Show();
                }
            }
        }

        private void loadToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (saveFileDialog1.FileName != "")
                openFileDialog1.FileName = saveFileDialog1.FileName;
            else
                openFileDialog1.FileName = "myProject";
            openFileDialog1.DefaultExt = "soap";
            openFileDialog1.Filter = "Soap files (*.soap)|*.soap";
            if (openFileDialog1.ShowDialog() == DialogResult.OK)
            {
                SoapFormatter formatter = new SoapFormatter();

                using (FileStream stream = new FileStream(openFileDialog1.FileName, FileMode.Open))
                {
                    this.project = (Project)formatter.Deserialize(stream);
                }
                saveFileDialog1.FileName = openFileDialog1.FileName;
                project.ShowTreeControl(treeView1);

                ToolStripItem[] tmp = settingsToolStripMenuItem.DropDownItems.Find("aItemplatesToolStripMenuItem", false);

                if (tmp.Length > 0)
                {
                    tmp[0].Enabled = true;
                }
            }
        }

        private void saveToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (saveFileDialog1.FileName == "")
                saveFileDialog1.FileName = "myProject";
            saveFileDialog1.DefaultExt = "soap";
            saveFileDialog1.Filter = "Soap files (*.soap)|*.soap";
            if (saveFileDialog1.ShowDialog() == DialogResult.OK)
            {
                SoapFormatter formatter = new SoapFormatter();

                using (FileStream stream = new FileStream(saveFileDialog1.FileName, FileMode.Create))
                {
                    formatter.Serialize(stream, this.project);
                }
            }
        }

        private void generatedemomodelToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (project.BindingTime == null)
            {
                MessageBox.Show("Please specify the binding time AiItem property first by setting up your AiTemplates.");

                aPVProject = new AllPossibleAiValues();
                aPVDiagram = new AllPossibleAiValues();
                aPVFeature = new AllPossibleAiValues();

                InitializeAiTemplate();
            }
            Diagram root = project.AddDiagram("diagram1");

            root.AddNode("feature", "F1");
            ((CardinalityHolder)root.GetNodeFromPath("F1")).Cardinality.SetCardinality(0, 1);

            root.AddNode("feature", "F2");
            ((CardinalityHolder)root.GetNodeFromPath("F2")).Cardinality.SetCardinality(2);

            root.GetNodeFromPath("F2").AddNode("feature", "F2-1");
            ((CardinalityHolder)root.GetNodeFromPath("F2.F2-1")).Cardinality.SetCardinality(0, 1);

            root.GetNodeFromPath("F2").AddNode("group", "G2-1");
            ((CardinalityHolder)root.GetNodeFromPath("F2.G2-1")).Cardinality.SetCardinality(1, 1);

            root.GetNodeFromPath("F2.G2-1").AddNode("feature", "F3a");
            root.GetNodeFromPath("F2.G2-1").AddNode("feature", "F3b");
            root.GetNodeFromPath("F2.G2-1").AddNode("feature", "F3c");
            root.GetNodeFromPath("F2.G2-1").AddNode("feature", "F3d");
            // transparentne grupy funguju...
            ((CardinalityHolder)root.GetNodeFromPath("F2.F3d")).Cardinality.SetCardinality(3);

            root.AddNode("feature", "F3");
            ((CardinalityHolder)root.GetNodeFromPath("F3")).Cardinality.SetCardinality(1, 2);

            root.Project.ShowTreeControl(treeView1);
        }

        private void aItemplatesToolStripMenuItem_Click(object sender, EventArgs e)
        {
            aPVProject = new AllPossibleAiValues();
            aPVDiagram = new AllPossibleAiValues();
            aPVFeature = new AllPossibleAiValues();

            InitializeAiTemplate();
            if(treeView1.SelectedNode!= null)
                textBox1.Text = ((TreeNode)treeView1.SelectedNode.Tag).DumpPublic();
        }

        private void constratinsToolStripMenuItem_Click(object sender, EventArgs e)
        {

        }

        private void removeToolStripMenuItem_Click(object sender, EventArgs e)
        {
            RemoveSelectedItem();
        }

        private void treeView1_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (treeView1.SelectedNode == null)
            {
                return;
            }

            TreeNode node = (TreeNode)treeView1.SelectedNode.Tag;
            if (node.GetType() == typeof(Project))
            {
                return;
            }

            if (e.KeyChar == (char)Keys.Delete || e.KeyChar == (char)Keys.Back)
            {
                RemoveSelectedItem();
            }
        }

        /// <summary>
        /// Metda odstrni selektnut uzol zo stromovej truktry.
        /// </summary>
        private void RemoveSelectedItem()
        {
            if (MessageBox.Show("Do you really want to remove selected node and all its descendants?", "Removal confirmation", MessageBoxButtons.YesNo) == DialogResult.Yes)
            {
                TreeNode node = (TreeNode)treeView1.SelectedNode.Tag;

                node.Parent.RemoveChild(node);
                treeView1.SelectedNode.Remove();
            }
        }

        private void validateCardinalityDependencies_Click(object sender, EventArgs e)
        {
            Diagram dgr = (Diagram)treeView1.SelectedNode.Tag;
            dgr.CanBeValid = true;

            if (validateCardDependencies(treeView1.SelectedNode))
            {
                MessageBox.Show("Validation was successful.", "Validation successful", MessageBoxButtons.OK, MessageBoxIcon.Information);
            }
            else
            {
                if (dgr.CanBeValid)
                {
                    MessageBox.Show("Validation was not successful.\r\nErrors were marked in the tree for you.", "Validation unsucessful", MessageBoxButtons.OK, MessageBoxIcon.Warning);
                }
                else
                {
                    MessageBox.Show("This instance can never be valid even in future instantiation times as it contains some invalid features which binding times are before current instantiation time. You can remove this instance right away and better think twice next time!", "Invalid instance", MessageBoxButtons.OK, MessageBoxIcon.Error);
                }
            }
        }

        /// <summary>
        /// Metda rekurzvne prejde strom od zadanho uzla a vyhodnot, i s splnen podmienky kardinality.
        /// Neplatn uzly ozna ervenou farbou.
        /// </summary>
        /// <param name="treeNode">Uzol, od ktorho sa prehadva</param>
        private bool validateCardDependencies(System.Windows.Forms.TreeNode treeNode)
        {
            DNode node = (DNode)treeNode.Tag;
			bool valid = true;

            if (node.GetType() == typeof(DFeature) || node.GetType() == typeof(DGroup))
            {
                if (node.Validate())
                {
					valid = true;
                    treeNode.BackColor = Color.White;
                }
                else
                {
					valid = false;
                    treeNode.BackColor = Color.Red;
                }
            }

            foreach (System.Windows.Forms.TreeNode childTreeNode in treeNode.Nodes)
            {
				if (this.validateCardDependencies(childTreeNode) == false)
				{
					valid = false;
				}
            }

			return valid;
        }

        private void newToolStripMenuItem_Click(object sender, EventArgs e)
        {
//            if (MessageBox.Show("Do you really want to start new Project?", "Removal confirmation", MessageBoxButtons.YesNo) == DialogResult.Yes) {}
            project = new Project();

            aPVProject = new AllPossibleAiValues();
            aPVDiagram = new AllPossibleAiValues();
            aPVFeature = new AllPossibleAiValues();

            nodeAiTemplate = null;

            InitializeAiTemplateWithoutDialog();

            ToolStripItem[] tmp = settingsToolStripMenuItem.DropDownItems.Find("aItemplatesToolStripMenuItem", false);

            if (tmp.Length > 0)
            {
                tmp[0].Enabled = true;
            }

            project.ShowTreeControl(treeView1);
        }

        private void changeNameToolStripMenuItem_Click(object sender, EventArgs e)
        {

            SetDiagramName dlgg = new SetDiagramName(((DNode)treeView1.SelectedNode.Tag).Name, "Edit Project Name");
            if (dlgg.ShowDialog() == DialogResult.OK)
            {
                ((DNode)treeView1.SelectedNode.Tag).SetID(dlgg.MyName);
            }

            treeView1.SelectedNode.Text = ((DNode)treeView1.SelectedNode.Tag).Id;
            textBox1.Text = ((DNode)treeView1.SelectedNode.Tag).DumpPublic();

        }

    }
}
