using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace FM
{
 
    /// <summary>
    /// Dialgov okno pre editciu mena uzla.
    /// </summary>
    public partial class SetDiagramName : Form
    {
        private String name;
        /// <summary>
        /// Meno uzla.
        /// </summary>
        public String MyName
        {
            get { return name; }
        }
        /// <summary>
        /// Kontruktor.
        /// </summary>
        /// <param name="text">Pvodn meno uzla.</param>
        public SetDiagramName(String text)
        {
            InitializeComponent();
            textBox1.Text = text;
            this.textBox1.Select();
            this.textBox1.SelectionStart = textBox1.Text.Length;
        }

        /// <summary>
        /// Kontruktor s urenm mena dialgovho okna.
        /// </summary>
        /// <param name="text">Pvodn meno uzla.</param>
        /// <param name="headline">Urenie mena dialgovho okna.</param>
        public SetDiagramName(String text, String headline)
        {
            InitializeComponent();
            textBox1.Text = text;
            this.Text = headline;
            this.textBox1.Select();
            this.textBox1.SelectionStart = textBox1.Text.Length;
        }

        private void button1_Click(object sender, EventArgs e)
        {
            name = textBox1.Text;
            this.DialogResult = DialogResult.OK;
        }

        private void textBox1_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (e.KeyChar == (char)Keys.Return)
            {
                name = textBox1.Text;
                this.DialogResult = DialogResult.OK;
            }
        }
    }
}